pipeline{
   agent any
   parameters{
        string(
            name: "VM_USERNAME",
            defaultValue: "ubuntu"
        )
        string(
            name: "VM_IP",
            defaultValue: "18.216.124.95"
        )
        string(
            name: "API_SERVICE",
            defaultValue: "api-inv.service"
        )
        string(
            name: "VM_JARNAME",
            defaultValue: "Api-Investimentos"
        )
   }
   post{
        success{
            echo "Sucesso na esteira!"
        }
        always {
            cleanWs()
        }
   }
   stages{
        stage("Test"){
            steps{
                sh "./mvnw test"
            }
        }
        stage("Build"){
            when {branch "master"}
            steps{
                sh "./mvnw package"
            }
        }
        stage("SCP"){
            when {branch "master"}
            steps{
                script{
                    def targetPath = sh(
                        script: "find target/ -name ${params.VM_JARNAME}-*.jar",
                        returnStdout:true
                    ).trim()
                    sh "scp -o StrictHostKeyChecking=no ${targetPath} ${params.VM_USERNAME}@${params.VM_IP}:~/Api-Investimentos"
                }
            }
        }
        stage("RestartService"){
            when {branch "master"}
            steps{
                sh "ssh -o StrictHostKeyChecking=no -t ${params.VM_USERNAME}@${params.VM_IP} sudo systemctl restart ${params.API_SERVICE}"
            }
        }
   }
}